<template>
  <div id="app">
    <book-search @newSearchQuery="performSearch" />
    <book-tiles :books="bookList" @selectBook="bookSelected" />
    <book-detail
      :book="selectedBook"
      v-if="selectedBook"
      @closeDetail="removeSelectedBook"
    />
  </div>
</template>

<script>
import BookSearch from "./components/BookSearch.vue";
import BookTiles from "./components/BookTiles.vue";
import BookDetail from "./components/BookDetail.vue";

import OpenLibraryApiService from "./services/OpenLibraryApiService.js";

export default {
  components: { BookSearch, BookTiles, BookDetail },
  data() {
    return {
      bookList: [],
      selectedBook: null,
    };
  },
  methods: {
    async performSearch(searchQuery) {
      this.bookList = await OpenLibraryApiService.searchForTitle(searchQuery);
    },
    bookSelected(book) {
      this.selectedBook = book;
    },
    removeSelectedBook() {
      this.selectedBook = null;
    },
  },
};
</script>

<style lang="scss">
#app {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-top: 60px;
}
</style>
